// Filename: commandline.h
// Name of author: Petr Kovar
// Work begun:    10/22/2002
// Last modified: 01/12/2006
//
// Description:
// Zpracovn paramter pkazov dky

// ------------------------------------------------------------------------------------------------------------------------

// Parametert pkazov dky
#ifndef __PARAMETERS__
#define __PARAMETERS__
typedef struct {
  int verbosity_level;           // level of printed comments
  int info_archiv;               // jak podrobn pst informace o souboru loh
  int info_resitele;             // jak podrobn pst informace o souboru eitel
  int info_body;                 // jak podrobn pst informace do souboru s archivem
  int info_ulohy;                // jak podrobn zapisovat nzvy loh do tabulky
  //D  int info_zamena;               // jak podrobn pst informace bhem zmny soubor

  char * in_file_resitele;       // name of the file for the input with resitele
  char * in_file_ulohy;          // name of the file for the input with ulohy
  char * out_file_resitele;      // name of the file for the output with resitele
  char * out_file_archiv;        // name of the file for the output with archive
  char * out_file_statistika;    // name of the file for the output with statistika

  char * archiv_head;            // name of the file with 'archiv' headers
  char * archiv_tail;            // name of the file with 'archiv' tails

  char * resitele_head;          // name of the file with 'resitele' headers
  char * resitele_mids;          // name of the file with 'resitele' middle
  char * resitele_tail;          // name of the file with 'resitele' tails

  char * statistika_head;        // name of the file with 'statistika' headers
  char * statistika_tail;        // name of the file with 'statistika' tails

  DATUM datum;                   // month and year of this archive
} PARAMETERS;
#endif // __PARAMETERS__


// constructor for parameter structure
PARAMETERS * new_parameters(void);

// free the PARAMETERS structure
int free_parameters(PARAMETERS * p_parameters);

// print how to use this program
void print_usage(void);

// go through all parameters, check them and store to * p_parameters
int scan_parameters(int argc, char ** argv, PARAMETERS * p_parameters);

// ------------------------------------------------------------------------------------------------------------------------

// end of file
