// Filename: messages.c
// Name of author: Petr Kovar
// Work begun:    10/08/2003
// Last modified: 04/01/2007
//
// Description:
// common message output functions

/*
Copyright (C) 2006 Petr Kov
You can reach me at Petr.Kovar@vsb.cz

-------------------------------------

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

// ------------------------------------------------------------------------------------------------------------------------

// Constatnts

// Libraries
#include <stdio.h>
#include <stdlib.h>
#include "messages.h"

/*D
// Various languages localization
#include <locale.h>
#include <libintl.h>

// Various languages localization
void language_localization(void) {
  setlocale (LC_MESSAGES, "");
  bindtextdomain (PACKAGE, LOCALEDIR);
  textdomain (PACKAGE);
}
*/

// print text only if not NULL
void nonempty_message(char *text) {
  if (text != NULL) {
    fprintf(stderr, " %s", text);
  }
  return;
}

// print a message
void message(int message, char * text) {
  // details
  switch (message) {

  // File handles:
  case CANT_OPEN_FILE_ULOHY:
    {
      fprintf(stderr, "Nemohu vstupn otet soubor pro 'ulohy':");
      nonempty_message(text);
    } break;
  case NOT_CLOSED_FILE_ULOHY:
    {
      fprintf(stderr, "Nemohu vstupn zavt soubor pro 'ulohy':");
      nonempty_message(text);
    } break;
  case CANT_OPEN_FILE_RESITELE:
    {
      fprintf(stderr, "Nemohu vstupn otet soubor pro 'resitele':");
      nonempty_message(text);
    } break;
  case NOT_CLOSED_FILE_RESITELE:
    {
      fprintf(stderr, "Nemohu vstupn zavt soubor pro 'resitele':");
      nonempty_message(text);
    } break;

    // File Structure 'lohy'
  case NO_ULOHY_IN_LIST:
    {
      fprintf(stderr, "V seznamu nen dn loha!");
      nonempty_message(text);
    } break;
  case NO_ULOHY_IN_FILE_ULOHY:
    {
      fprintf(stderr, "dn loha v souboru 'ulohy':");
      nonempty_message(text);
    } break;
  case NOT_COMPLETE_DATA:
    {
      fprintf(stderr, "Nepln data v souboru 'ulohy':");
      nonempty_message(text);
    } break;
  case LINE_ULOHY_TOO_LONG:
    {
      fprintf(stderr, "dek souboru 'ulohy' je pli dlouh:");
      nonempty_message(text);
    } break;
  case NO_NUMBER_GIVEN:
    {
      fprintf(stderr, "Nen zadno slo lohy v souboru 'ulohy':");
      nonempty_message(text);
    } break;
  case ULOHA_INDEX_NOT_NUMBER:
    {
      fprintf(stderr, "slo lohy nen integer:");
      nonempty_message(text);
    } break;

    // File Structure 'een'
  case NO_RESENI_IN_FILE_RESITELE:
    {
      fprintf(stderr, "dn een v souboru 'resitele':");
      nonempty_message(text);
    } break;
  case LINE_RESENI_TOO_LONG:
    {
      fprintf(stderr, "dek souboru 'resitele' je pli dlouh:");
      nonempty_message(text);
    } break;

    // Archives
  case NO_ARCHIVE_NAME:
    {
      fprintf(stderr, "Chyb jmno archivu v souboru 'ulohy':");
      nonempty_message(text);
    } break;
  case NO_ULOHA_INDEX:
    {
      fprintf(stderr, "Chyb index lohy v souboru 'ulohy':");
      nonempty_message(text);
    } break;
  case NO_ULOHA_NAME_GIVEN:
    {
      fprintf(stderr, "Chyb jmnno lohy v souboru 'ulohy':");
      nonempty_message(text);
    } break;
  case NO_POINTS_GIVEN:
    {
      fprintf(stderr, "Chyb body za lohu v souboru 'ulohy':");
      nonempty_message(text);
    } break;
  case POINTS_ARE_NOT_INTEGER:
    {
      fprintf(stderr, "Body za lohu nejsou integer v souboru 'ulohy':");
      nonempty_message(text);
    } break;
  case ULOHA_TWICE:
    {
      fprintf(stderr, "Dv lohy se stejnm slem v souboru 'ulohy':");
      nonempty_message(text);
    } break;
  case ARCHIV_TWICE:
    {
      fprintf(stderr, "Dva archivy se stejnm slem:");
      nonempty_message(text);
    } break;

    // een
  case NO_DATE_GIVEN:
    {
      fprintf(stderr, "patn datum v souboru 'resitele':");
      nonempty_message(text);
    } break;
  case NO_RESITEL_NAME_GIVEN:
    {
      fprintf(stderr, "dn jmnno eitele v souboru 'resitele':");
      nonempty_message(text);
    } break;
  case INCOMPLETE_ID:
    {
      fprintf(stderr, "slo lohy nen kompletn:");
      nonempty_message(text);
    } break;
  case WRONG_DATE_FORMAT:
    {
      fprintf(stderr, "Datum mus bt formtu 'D.M.Y' v souboru 'resitele'.");
      nonempty_message(text);
    } break;
  case ULOHA_NOT_IN_ARCHIVE:
    {
      fprintf(stderr, "Vyeen loha nen v archivu:");
      nonempty_message(text);
    } break;
  case MORE_POINTS_THAN_TOTAL:
    {
      fprintf(stderr, "eitel dostal v souboru 'resitele' vce bod, ne je maximum za lohu.");
      nonempty_message(text);
    } break;
  case POINTS_NOT_GIVEN:
    {
      fprintf(stderr, "Body za lohu nejsou integer v souboru 'resitele':");
      nonempty_message(text);
    } break;
  case VYRESENA_ULOHA_TWICE:
    {
      fprintf(stderr, "Jeden eitel eil stejnou lohy vcekrt!");
      nonempty_message(text);
    } break;
  case RESENI_NOT_CHRONOLOGIC:
    {
      fprintf(stderr, "een nejsou v souboru een chronologicky.");
      nonempty_message(text);
    } break;

    // Other
  case DATUM_NOT_ALLOCATED:
    {
      fprintf(stderr, "Nen alokovan pam pro datum.");
      nonempty_message(text);
    } break;
  case ERROR_IN_RESITEL_STRUCTURE:
    {
      fprintf(stderr, "Chyba ve struktue eitel: nesed poet eitel!");
      nonempty_message(text);
    } break;
  case NO_OUTPUT_FILE:
    {
      fprintf(stderr, "Nen zadn vstupn soubor pro koprovn!");
      nonempty_message(text);
    } break;
  case NO_INPUT_FILE:
    {
      fprintf(stderr, "Nen zadn vstupn soubor pro koprovn!");
      nonempty_message(text);
    } break;
  case RESITEL_TWICE:
    {
      fprintf(stderr, "Dva eitel se stejnm jmnem:");
      nonempty_message(text);
    } break;

    // Generovn archivu
  case CANT_OPEN_ARCHIV_FILE:
    {
      fprintf(stderr, "Nemohu otevt vstupn soubor 'archiv':");
      nonempty_message(text);
    } break;
  case NOT_CLOSED_ARCHIV_FILE:
    {
      fprintf(stderr, "Nemohu zavt vstupn soubor 'archiv':");
      nonempty_message(text);
    } break;

  case CANT_OPEN_ARCHIV_HEADINGS:
    {
      fprintf(stderr, "Nemohu otevt hlaviku archivu:");
      nonempty_message(text);
    } break;
  case NOT_CLOSED_ARCHIV_HEADINGS:
    {
      fprintf(stderr, "Nemohu zavt hlaviku archivu:");
      nonempty_message(text);
    } break;
  case CANT_OPEN_ARCHIV_TAILS:
    {
      fprintf(stderr, "Nemohu otevt patiku archivu:");
      nonempty_message(text);
    } break;
  case NOT_CLOSED_ARCHIV_TAILS:
    {
      fprintf(stderr, "Nemohu zavt patiku archivu:");
      nonempty_message(text);
    } break;

    // Generovn tabulky eitel
  case NO_RESITELE_IN_LIST:
    {
      fprintf(stderr, "V seznamu nen dn eitel!");
      nonempty_message(text);
    } break;
  case CANT_OPEN_RESITELE_FILE:
    {
      fprintf(stderr, "Nemohu otevt vstupn soubor 'resitele':");
      nonempty_message(text);
    } break;
  case NOT_CLOSED_RESITELE_FILE:
    {
      fprintf(stderr, "Nemohu zavt vstupn soubor 'resitele':");
      nonempty_message(text);
    } break;

  case CANT_OPEN_RESITELE_HEADINGS:
    {
      fprintf(stderr, "Nemohu otevt hlaviku souboru eitel:");
      nonempty_message(text);
    } break;
  case NOT_CLOSED_RESITELE_HEADINGS:
    {
      fprintf(stderr, "Nemohu zavt hlaviku souboru eitel:");
      nonempty_message(text);
    } break;
  case CANT_OPEN_RESITELE_MIDS:
    {
      fprintf(stderr, "Nemohu otevt middle souboru eitel:");
      nonempty_message(text);
    } break;
  case NOT_CLOSED_RESITELE_MIDS:
    {
      fprintf(stderr, "Nemohu zavt middle souboru eitel:");
      nonempty_message(text);
    } break;
  case CANT_OPEN_RESITELE_TAILS:
    {
      fprintf(stderr, "Nemohu otevt patiku souboru eitel:");
      nonempty_message(text);
    } break;
  case NOT_CLOSED_RESITELE_TAILS:
    {
      fprintf(stderr, "Nemohu zavt patiku souboru eitel:");
      nonempty_message(text);
    } break;

    // Generovn statistiskch tabulek
  case CANT_OPEN_STATISTIKA_FILE:
    {
      fprintf(stderr, "Nemohu otevt vstupn soubor 'statistika':");
      nonempty_message(text);
    } break;
  case NOT_CLOSED_STATISTIKA_FILE:
    {
      fprintf(stderr, "Nemohu zavt vstupn soubor 'statistika':");
      nonempty_message(text);
    } break;

  case CANT_OPEN_STATISTIKA_HEADINGS:
    {
      fprintf(stderr, "Nemohu otevt hlaviku statistikau:");
      nonempty_message(text);
    } break;
  case NOT_CLOSED_STATISTIKA_HEADINGS:
    {
      fprintf(stderr, "Nemohu zavt hlaviku statistikau:");
      nonempty_message(text);
    } break;
  case CANT_OPEN_STATISTIKA_TAILS:
    {
      fprintf(stderr, "Nemohu otevt patiku statistikau:");
      nonempty_message(text);
    } break;
  case NOT_CLOSED_STATISTIKA_TAILS:
    {
      fprintf(stderr, "Nemohu zavt patiku statistikau:");
      nonempty_message(text);
    } break;

    /*
  case NO_RESENA_ULOHA_FOR_RESITEL:
    {
      fprintf(stderr, "No resena 'uloha' for the resitel:");
      nonempty_message(text);
    } break;
    */

  default:
    {
      fprintf(stderr, "%d", message);
    }
  }
  // new line at the end of the message
  fprintf(stderr, "\n");
  return;
}

// print an error message
void error_message(int error_message, char * text) {
  // general error message
  fprintf(stderr, "Error: ");
  // the message
  message(error_message, text);
  // do NOT return, but exit on error
  exit(error_message);
}

// print a warning message
void warning_message(int warning_message, char * text) {
  // general error message
  fprintf(stderr, "----\n");
  fprintf(stderr, "Warning: ");
  // the message
  message(warning_message, text);
  fprintf(stderr, "----\n");
  // go back
  return;
}

// ------------------------------------------------------------------------------------------------------------------------

// end of file
