// Filename: resitele_types.h
// Name of author: Petr Kovar
// Work begun:    28/12/2004
// Last modified: 04/01/2007
//
// Description:
// data types for structures used program 'resitele'
/*
Copyright (C) 2006 Petr Kov
You can reach me at Petr.Kovar@vsb.cz

-------------------------------------

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

// ------------------------------------------------------------------------------------------------------------------------

// Konstanty
//D#define NORMAL_LINE        0
//D#define LONG_LINE          8
#define TYP_CISLA_NULL     0     // jet dn slo
#define TYP_CISLA_STR      1     // slo je stringem
#define TYP_CISLA_NUM      2     // slo je unsigned int
#define MAX_ARCHIV         8000  // maximln slo archivu
//?#define MAX_ARCHIV_SIZE    25    // maximln poet loh v archivu

#define MAX_RADEK          1000  // maximln dlka stringu
#define MAX_CISLO_ARCHIVU  20    // maximln dlka stringu jmna/sla archivu
#define MAX_INDEX_ULOHY    20    // maximln dlka stringu jmna/sla lohy
#define MAX_KOMENTAR       500   // maximln dlka stringu komente k een
#define VERY_SHORT_LINE_ULOHY    6     // pli krtk dek vstupnho souboru loh
#define VERY_SHORT_LINE_RESITELE 8     // pli krtk dek vstupnho souboru een
#define OK                 0
#define ANO                1
#define NE                 0

// Nov typy

// Nvratov hodnota
#ifndef __STATUS__
#define __STATUS__
typedef unsigned short STATUS;   // Status nvratu: ANO, NE, OK
#endif // __STATUS__

// Datum een
#ifndef __DATUM__
#define __DATUM__
typedef struct {
  int den;       // den v msci
  int mesic;     // msc
  int rok;       // rok
} DATUM;
#endif // __DATUM__


// Koment k een
#ifndef __KOMENTAR__
#define __KOMENTAR__
typedef char * KOMENTAR;
#endif // __KOMENTAR__


// Jmno eitele
#ifndef __JMENO_RESITELE__
#define __JMENO_RESITELE__
typedef char * JMENO_RESITELE;
#endif // __JMENO_RESITELE__


// Jmno lohy
#ifndef __JMENO_ULOHY__
#define __JMENO_ULOHY__
typedef char * JMENO_ULOHY;
#endif // __JMENO_ULOHY__


// Typ sla archivu a lohy: string nebo int?
#ifndef __TYP__
#define __TYP__
typedef unsigned short TYP;   // Typ sla archivu a lohy
#endif // __TYP__

// Jmno
#ifndef __JMENO__
#define __JMENO__
typedef char * JMENO;
#endif // __JMENO__

// slo
#ifndef __CISLO__
#define __CISLO__
typedef int CISLO;
#endif // __CISLO__

// Body za lohu
#ifndef __BODY__
#define __BODY__
typedef unsigned int BODY;
#endif // __BODY__

// Poet een
#ifndef __POCET_RESENI__
#define __POCET_RESENI__
typedef unsigned long int POCET_RESENI;
#endif // __POCET_RESENI__

// slo dku
#ifndef __CISLO_RADKU__
#define __CISLO_RADKU__
typedef unsigned long int CISLO_RADKU;
#endif // __CISLO_RADKU__


// Jedna loha
#ifndef __ULOHA__
#define __ULOHA__
typedef struct _ULOHA ULOHA;

// Jeden archiv obsahuje vce loh (seznam vech loh)
#ifndef __ARCHIV__
#define __ARCHIV__
typedef struct _ARCHIV ARCHIV;

// eitel loh (seznam vech eitel)
#ifndef __RESITEL__
#define __RESITEL__
typedef struct _RESITEL RESITEL;

// Jedno konkrtn een tto lohy (seznam pro lohu)
#ifndef __RESENI_ULOHY__
#define __RESENI_ULOHY__
typedef struct _RESENI_ULOHY RESENI_ULOHY;


// Jedna loha v archivu (seznam vech loh)
struct _ULOHA {
  ARCHIV * p_archiv;                     // pointer na archiv, ve kterm je loha
  CISLO index_ulohy;                     // slo (index) lohy jako slo
  CISLO_RADKU radek_souboru;             // slo dku souboru
  JMENO_ULOHY jmeno_ulohy;               // jmno tto lohy
  BODY body_ulohy;                       // maximln poet bod za lohu
  ULOHA * p_next_uloha;                  // pointer na dal lohu
  RESENI_ULOHY * p_first_reseni_ulohy;   // prvn een tto lohy
  POCET_RESENI n_reseni;                 // poet een tto 'lohy'
  POCET_RESENI n_uplnych_reseni;         // poet plnch een tto 'lohy'
};
#endif // __ULOHA__


// Jeden archiv obsahuje vce loh (seznam vech loh)
struct _ARCHIV {
  TYP typ_jmena_archivu;                 // jak je uloeno jmno archivu?
  JMENO jmeno_archivu;                   // jmno archivu jako string
  CISLO cislo_archivu;                   // jmno archivu jako slo
  ULOHA * p_first_uloha;                 // pointer na prvn 'loha'
  int n_uloh_v_archivu;                  // poet loh v archivu
  ARCHIV * p_next_archiv;                // pointer na dal archiv
};
#endif // __TYP_ARCHIV__


// Seznam loh seazen do archiv (seznam vech loh)
#ifndef __SEZNAM_ULOH__
#define __SEZNAM_ULOH__
typedef struct {
  ARCHIV * p_first_archiv;      // pointer na prvn archv
  int n_archivu;                // poet archiv
  int n_uloh;                   // poet loh
} SEZNAM_ULOH;
#endif // __SEZNAM_ULOH__


// Jedno een
#ifndef __RESENI__
#define __RESENI__
typedef struct _RESENI RESENI;

// Jedna loha v archivu (odpovdi od vech eitel)
struct _RESENI {
  ULOHA * p_uloha;                        // pointer na 'lohu' jej een toto je
  ARCHIV * p_archiv;                      // pointer na archiv, ve kterm je tato loha
  RESITEL * p_resitel;                    // pointer na eitele tto lohy
  DATUM datum;                            // datum, kdy bylo een zapsno
  KOMENTAR komentar;                      // koment k tomuto een
  BODY body_reseni;                       // body udlen za tuto 'lohu'
  CISLO_RADKU radek_souboru;              // slo dku souboru
  RESENI * p_next_reseni;                 // pointer na dal lohu
};
#endif // __TYP_RESENI_ARCHIV__


// Seznam een (odpovdi od vech eitel)
#ifndef __SEZNAM_RESENI__
#define __SEZNAM_RESENI__
typedef struct {
  RESENI * p_first_reseni;                // pointer na prvn een
  POCET_RESENI n_reseni;                  // poet een
} SEZNAM_RESENI;
#endif // __SEZNAM_RESENI__


// Jedno een lohy konkrtnho eitele (seznam pro kadho eitele)
#ifndef __RESENA_ULOHA__
#define __RESENA_ULOHA__
typedef struct _RESENA_ULOHA RESENA_ULOHA;

struct _RESENA_ULOHA {
  RESENI * p_reseni;                     // pointer na een tto lohy
  RESENA_ULOHA * p_next_resena_uloha;    // pointer na dal een tohoto eitele
};
#endif // __RESENA_ULOHA__	 


// Jedno konkrtn een tto lohy (seznam pro lohu)
struct _RESENI_ULOHY {
  RESENI * p_reseni;                     // pointer na een tto lohy
  RESENI_ULOHY * p_next_reseni_ulohy;    // pointer na dal een tto lohy
};
#endif // __RESENI_ULOHY__	 


// Jeden eitel loh (seznam vech eitel)
struct _RESITEL {			 
  JMENO jmeno_resitele;                  // cel jmno 'eitele'
  // url
  // rok narozen
  BODY suma_bodu;                        // celkov poet bod
  POCET_RESENI pocet_uloh;               // celkov poet vyeench loh
  POCET_RESENI pocet_plnych_uloh;        // poet vyeench loh za pln poet bod
  RESENA_ULOHA * p_first_resena_uloha;   // pointer na prvn vyeenou lohu
  RESITEL * p_next_resitel;              // pointer na dalho eitele
};
#endif // __RESITEL__

// seznam eeitel (seznam vech eitel)
#ifndef __SEZNAM_RESITELU__
#define __SEZNAM_RESITELU__
typedef struct {
  RESITEL * p_first_resitel;             // pointer na prvnho eitele
  int n_resitelu;                        // poet eitel
} SEZNAM_RESITELU;
#endif // __SEZNAM_RESITELU__


// Poloka seznamu s pointery na lohy (pro statistiku)
#ifndef __ULOHA_ELEMENT__
#define __ULOHA_ELEMENT__
typedef struct _ULOHA_ELEMENT ULOHA_ELEMENT;

struct _ULOHA_ELEMENT {
  ULOHA * p_uloha;                       // pointer na lohu
  ULOHA_ELEMENT * p_next_uloha_element;  // pointer na dal poloku seznamu
};
#endif // __ULOHA_ELEMENT__


// Seznam s pointery na lohy (pro statistiku)
#ifndef __SADA_ULOH__
#define __SADA_ULOH__
typedef struct {
  ULOHA_ELEMENT * p_first_uloha_element; // pointer na prvn prvek seznamu
  int n_uloh;                            // poet loh
} SADA_ULOH;
#endif // __SADA_ULOH__


// Poloka seznamu s pointery na eitele (pro statistiku)
#ifndef __RESITEL_ELEMENT__
#define __RESITEL_ELEMENT__
typedef struct _RESITEL_ELEMENT RESITEL_ELEMENT;

struct _RESITEL_ELEMENT {
  RESITEL * p_resitel;                   // pointer na eitele
  RESITEL_ELEMENT * p_next_resitel_element;  // pointer na dal poloku seznamu
};
#endif // __RESITEL_ELEMENT__


// Seznam s pointery na eitele (pro statistiku)
#ifndef __SADA_RESITELU__
#define __SADA_RESITELU__
typedef struct {
  RESITEL_ELEMENT * p_first_resitel_element;  // pointer na prvn prvek seznamu
  int n_resitelu;                        // poet eitel
} SADA_RESITELU;
#endif // __SADA_RESITELU__


// daje o eiteli
/*?
jmno
rok narozen
pohlav
*/



// ------------------------------------------------------------------------------------------------------------------------

// end of file
